<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xd="http://www.oxygenxml.com/ns/doc/xsl"
    xmlns:my="file://./rules.xsl"
    exclude-result-prefixes="xs xd"
    version="2.0">

    <xsl:import href="rules.xsl"/>    

    <xsl:output method="text" />
    <xsl:strip-space elements="*" />
    
    <xsl:template match="@navtitle" mode="toc_title">
        <xsl:variable name="title_text" select="normalize-space(.)"/>
        <xsl:variable name="title_len" select="string-length($title_text)"/>
        <xsl:value-of select="my:repeat('=',$title_len)"/>
        <xsl:value-of select="concat('&#xA;',$title_text,'&#xA;')"/>
        <xsl:value-of select="my:repeat('=',$title_len)"/>
        <xsl:text>&#xA;</xsl:text>
    </xsl:template>

    <xsl:template match="topicref">
        <xsl:param name="ppath" select="''"/>
        <xsl:variable name="filename" select="replace(@href,'.xml','.rst')" />
        <xsl:value-of select="concat('   ',substring-after($filename,$ppath),'&#xA;')"/>
        <xsl:result-document href="{$filename}">
            <xsl:variable name="path" select="replace($filename,'/[^/]*$','/')"/>
            <xsl:apply-templates select="@navtitle" mode="toc_title"/>
            <xsl:apply-templates select="document(@href)"/>
            <xsl:if test="child::topicref">
                <xsl:text>&#xA;&#xA;.. toctree::&#xA;&#xA;</xsl:text>
                <xsl:apply-templates select="topicref"><xsl:with-param name="ppath" select="$path"/></xsl:apply-templates>
            </xsl:if>
        </xsl:result-document>
    </xsl:template>

    <xsl:template match="map">
        <xsl:result-document href="index.rst">
            <xsl:text>.. toctree::&#xA;   :caption: Contents:&#xA;&#xA;</xsl:text>
            <xsl:apply-templates select="topicref"/>
        </xsl:result-document>
    </xsl:template>
    
</xsl:stylesheet>
