<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xd="http://www.oxygenxml.com/ns/doc/xsl"
    xmlns:my="file://./rules.xsl"
    exclude-result-prefixes="xs xd"
    version="2.0">

    <xsl:import href="rules.xsl"/>

    <xsl:output method="text" />
    <xsl:strip-space elements="*" />
    
    <xsl:template match="title" mode="page_title">
        <xsl:variable name="title_text" select="normalize-space(.)"/>
        <xsl:variable name="title_len" select="string-length($title_text)"/>
        <xsl:value-of select="my:repeat('=',$title_len)"/>
        <xsl:value-of select="concat('&#xA;',$title_text,'&#xA;')"/>
        <xsl:value-of select="my:repeat('=',$title_len)"/>
        <xsl:text>&#xA;</xsl:text>
    </xsl:template>
    
    <xsl:template match="topic|reference">
        <xsl:variable name="filename" select="concat(@id,'.rst')" />
        <xsl:value-of select="$filename" /> 
        <xsl:result-document href="{$filename}">
            <xsl:apply-templates select="title" mode="page_title"/>
            <xsl:apply-templates select="body|refbody|related-links"/>
        </xsl:result-document>
    </xsl:template>
    
</xsl:stylesheet>
